﻿Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.EditorInput

Public Class Form1
    Private Sub tinh(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtso1.TextChanged
        Dim txt1, txt2, txtres As Double
        txt1 = Val(txtso1.Text)
        txt2 = Val(txtso2.Text)
        If cbb.Text = "Phép cộng" Then
            txtres = txt1 + txt2
        End If
        If cbb.Text = "Phép Trừ" Then
            txtres = txt1 - txt2
        End If
        If cbb.Text = "Phép Nhân" Then
            txtres = txt1 * txt2
        End If
        If cbb.Text = "Phép Chia" Then
            txtres = txt1 / txt2
        End If
        txtkq.Text = txtres
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        With cbb.Items
            .Add("Phép cộng")
            .Add("Phép Trừ")
            .Add("Phép Nhân")
            .Add("Phép Chia")
        End With
        cbb.Text = "Phép cộng"
    End Sub

    Private Sub cbb_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbb.SelectedIndexChanged
        If cbb.Text = "Phép cộng" Then
            btnso1.Text = "Số hạng 1"
            btnso2.Text = "Số hạng 2"
            btnkq.Text = "TỎNG"
        End If
        If cbb.Text = "Phép Trừ" Then
            btnso1.Text = "Số bị trừ"
            btnso2.Text = "Số trừ"
            btnkq.Text = "HIỆU"
        End If
        If cbb.Text = "Phép Nhân" Then
            btnso1.Text = "Thừa số 1"
            btnso2.Text = "Thừa số 2"
            btnkq.Text = "TÍCH"
        End If
        If cbb.Text = "Phép Chia" Then
            btnso1.Text = "Số bị chia"
            btnso2.Text = "Số chia"
            btnkq.Text = "THƯƠNG"
        End If
        Call tinh(sender, e)
    End Sub


    Private Sub txtso1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtso1.TextChanged
        Call tinh(sender, e)
    End Sub

    Private Sub txtso2_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtso2.TextChanged
        Call txtso1_TextChanged(sender, e)
    End Sub

    Private Sub btnso1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnso1.Click
        Dim activeDoc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument
        Dim db As Database = activeDoc.Database
        Dim ed As Editor = activeDoc.Editor

        Dim peo As New PromptEntityOptions("Chon text 1")
        peo.SetRejectMessage("Khong phai Text. Chon lai")
        peo.AddAllowedClass(GetType(DBText), True)
        Dim per As PromptEntityResult = ed.GetEntity(peo)

        If per.Status = PromptStatus.OK Then
            Using Tx As Transaction = db.TransactionManager.StartTransaction()
                Dim dbText As DBText = TryCast(Tx.GetObject(per.ObjectId, OpenMode.ForWrite), DBText)
                txtso1.Text = dbText.TextString
            End Using
        End If
    End Sub

    Private Sub btnso2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnso2.Click
        Dim activeDoc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument
        Dim db As Database = activeDoc.Database
        Dim ed As Editor = activeDoc.Editor

        Dim peo As New PromptEntityOptions("Pick text 2")
        peo.SetRejectMessage("Khong phai Text. Chon lai")
        peo.AddAllowedClass(GetType(DBText), True)
        Dim per As PromptEntityResult = ed.GetEntity(peo)

        If per.Status = PromptStatus.OK Then
            Using Tx As Transaction = db.TransactionManager.StartTransaction()
                Dim dbText As DBText = TryCast(Tx.GetObject(per.ObjectId, OpenMode.ForWrite), DBText)
                txtso2.Text = dbText.TextString
            End Using
        End If
    End Sub


End Class


Public Class Commands
    <CommandMethod("combobox")> _
    Public Sub combobox()
        Autodesk.AutoCAD.ApplicationServices.Application.ShowModalDialog(New Form1())
    End Sub

    <CommandMethod("ToExcel")> _
    Public Sub ToExcel()
        ' Ghi ra Excel
        Dim objApp As Object
        Dim objBook As Object
        Dim objBooks As Object
        Dim objSheets As Object
        Dim objSheet As Object
        Dim range As Object
        objApp = CreateObject("Excel.Application")
        objBooks = objApp.Workbooks
        objBook = objBooks.Add
        objSheets = objBook.Worksheets
        objSheet = objSheets.Item(1)

        Dim lst As New ArrayList()
        lst.Add("A1")
        lst.Add("B1")
        lst.Add("C1")
        'range = objSheet.Range("A1", Chr(lst.Count + 64) & "1")
        range = objSheet.Range("A1", "C1")
        range.Value = lst.ToArray()
        'range.Columns.AutoFit()

        lst.Clear()
        lst.Add("B3")
        lst.Add("C3")
        lst.Add("D3")
        range = objSheet.Range("B3", "D3")
        range.Value = lst.ToArray()

        objApp.Visible = True
        objApp.UserControl = True
    End Sub

    <CommandMethod("HighlightSelection")> _
    Public Sub HighlightSelection()
        Dim doc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument
        Dim db As Database = doc.Database
        Dim ed As Editor = doc.Editor
        Dim ids As List(Of ObjectId) = New List(Of ObjectId)

        Dim opts As New PromptEntityOptions(vbLf & "Chọn Obj : ")
        While True
            Dim res As PromptEntityResult = ed.GetEntity(opts)
            If res.Status = PromptStatus.OK Then
                Dim id As ObjectId = res.ObjectId
                Using Tx As Transaction = db.TransactionManager.StartTransaction()
                    Dim ent As Entity = TryCast(Tx.GetObject(id, OpenMode.ForRead), Entity)
                    ent.Highlight()
                End Using
                ids.Add(id)
            Else
                Exit While
            End If
        End While
        ed.SetImpliedSelection(ids.ToArray())
    End Sub


End Class